stages:
- build-and-execute-integrationtests
#- build-and-dockerize-integrationtests
#- execute-integrationtests

build-and-execute-integrationtests:
  stage: build-and-execute-integrationtests
  image: maven:3.5.4-jdk-10-slim
  services:
  - mysql:8.0.12
  - rabbitmq:3.7.7-management-alpine
  variables:
    MYSQL_ROOT_PASSWORD: root
    MYSQL_DATABASE: dev
    RABBITMQ_DEFAULT_USER: guest
    RABBITMQ_DEFAULT_PASS: guest
    SPRING_DATASOURCE_URL: jdbc:mysql://mysql:3306/dev?allowPublicKeyRetrieval=true&useSSL=false
    SPRING_RABBITMQ_HOST: rabbitmq
    BOOKINGSERVICE_BASE_URL: http://localhost:8080
    SERVICE_ARTIFACTS: "bookingservice portcheckinservice"
    SERVICE_PORTS: "8080 8081"
    GROUP_ID: "com.adia.srs"
  script:
  # install additional components
  - apt-get update && apt-get install -y git
  # fetch services from maven repository
  - ./downloadAndStartServices.sh $GROUP_ID "$SERVICE_ARTIFACTS" "$SERVICE_PORTS"
  - echo "Spring-logs can be found in files \"spring_<servicename>.log\" which can be downloaded as artifacts in gitlab (Pipelines-view)."
  - ./wait-for-service.sh bookingservice http://localhost:8080/actuator/health
  - ./wait-for-service.sh portcheckinservice http://localhost:8081/actuator/health
  # build and test service
  - chmod +x ./gradlew
  - ./gradlew build
  artifacts:
    when: always
    paths:
    - build/reports/
    - build/libs/
    - spring_*.log
  only:
  - master
  - triggers

#dockerize-application:
#  stage: dockerize-application
#  image: nexus.informatik.haw-hamburg.de/docker:icc-dind
#  variables:
#    DOCKER_HOST: tcp://localhost:2375
#  services:
#  - nexus.informatik.haw-hamburg.de/docker:dind
#  script:
#  - export SERVICE_JAR_FILE="./build/libs/`ls ./build/libs | grep -v stubs`"
#  - printf "Service-jar path is \"$SERVICE_JAR_FILE\"\n"
#  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
#  - docker build --build-arg JAR_FILE=$SERVICE_JAR_FILE --tag $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
#  - docker push $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID
#  - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
#  - docker push $CI_REGISTRY_IMAGE:latest
#  dependencies:
#  - build-and-test
#  only:
#  - master

#build-and-dockerize-integrationtests:
#  stage: build-and-dockerize-integrationtests
#  image: docker:stable
#  variables:
#    DOCKER_HOST: tcp://docker:2375
#    DOCKER_DRIVER: overlay2
#  services:
#  - docker:dind
#  script:
#  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
#  - docker build --tag $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
#  - docker push $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID
#  - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
#  - docker push $CI_REGISTRY_IMAGE:latest
#  except:
#  - triggers

#execute-integrationtests:
#  stage: execute-integrationtests
#  image: docker:stable
#  variables:
#    DOCKER_HOST: tcp://docker:2375
#    DOCKER_DRIVER: overlay2
#    MYSQL_ROOT_PASSWORD: root
#    MYSQL_DATABASE: dev
#    RABBITMQ_DEFAULT_USER: guest
#    RABBITMQ_DEFAULT_PASS: guest
#    SPRING_DATASOURCE_URL: jdbc:mysql://mysql:3306/dev?allowPublicKeyRetrieval=true&useSSL=false
#    SPRING_RABBITMQ_HOST: rabbitmq
#  services:
#  - docker:dind
#  script:
#  - echo Starting containers
#  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
#  - docker network create my_docker_network
#  - docker run --name mysql --network=my_docker_network -d -p 3306:3306 -e MYSQL_ROOT_PASSWORD=$MYSQL_ROOT_PASSWORD -e MYSQL_DATABASE=$MYSQL_DATABASE mysql:8.0.12
#  - docker run --name rabbitmq --network=my_docker_network -d -p 5672:5672 -p 15672:15672 -e RABBITMQ_DEFAULT_USER=$RABBITMQ_DEFAULT_USER -e RABBITMQ_DEFAULT_PASS=$RABBITMQ_DEFAULT_PASS rabbitmq:3.7.7-management-alpine
#  - docker run --name bookingservice --network=my_docker_network -d -p 8080:8080 -e SPRING_DATASOURCE_URL=$SPRING_DATASOURCE_URL -e SPRING_RABBITMQ_HOST=$SPRING_RABBITMQ_HOST registry.gitlab.com/sarstedt/adia/bookingservice:latest
#  - echo Executing integration tests
#  - docker run --name integrationtests --network=my_docker_network -e BOOKINGSERVICE_BASE_URL=http://bookingservice:8080 registry.gitlab.com/sarstedt/adia/integration:latest
#  - echo Removing containers
#  - docker rm -f bookingservice
#  - docker rm -f rabbitmq
#  - docker rm -f mysql
#  - docker network rm my_docker_network
#  only:
#  - triggers

